/* This is a demo that shows the different types of browsers.

   Written by Mark Overmars

   Date: 29 Apr 1991
*/

#include <stdio.h>
#include <strings.h>
#include "forms.h"

FL_FORM *form;
FL_OBJECT *br[4], *exitobj, *readout;

void deselect(FL_OBJECT *obj, long arg)
{
  int i;
  for (i=0; i<4; i++) fl_deselect_browser(br[i]);
}

void set_size(FL_OBJECT *obj, long arg)
{
  int i;
  for (i=0; i<4; i++) fl_set_browser_fontsize(br[i],arg);
}

void set_style(FL_OBJECT *obj, long arg)
{
  int i;
  for (i=0; i<4; i++) fl_set_browser_fontstyle(br[i], (int) arg);
}

void create_form()
{
  FL_OBJECT *obj;
  form = fl_bgn_form(FL_UP_BOX,700.0,570.0);
  readout = fl_add_box(FL_UP_BOX,50.0,490.0,600.0,50.0,"BROWSER TYPES");
  fl_set_object_lsize(readout,FL_LARGE_FONT);
  fl_set_object_lstyle(readout,FL_BOLD_STYLE);
  fl_set_object_color(readout,5,5);
  br[0] = fl_add_browser(FL_NORMAL_BROWSER,20.0,160.0,150.0,290.0,"NORMAL_BROWSER");
  br[1] = fl_add_browser(FL_SELECT_BROWSER,190.0,160.0,150.0,290.0,"SELECT_BROWSER");
  br[2] = fl_add_browser(FL_HOLD_BROWSER,360.0,160.0,150.0,290.0,"HOLD_BROWSER");
    fl_set_object_color(br[2],47,2);
  br[3] = fl_add_browser(FL_MULTI_BROWSER,530.0,160.0,150.0,290.0,"MULTI_BROWSER");
    fl_set_object_color(br[3],47,6);
  exitobj = obj = fl_add_button(FL_NORMAL_BUTTON,560.0,30.0,120.0,30.0,"Exit");
  obj = fl_add_button(FL_NORMAL_BUTTON,560.0,80.0,120.0,30.0,"Deselect");
    fl_set_call_back(obj,deselect,0);
  fl_bgn_group();
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,20.0,80.0,120.0,30.0,"Small");
    fl_set_object_lsize(obj,FL_SMALL_FONT);
    fl_set_call_back(obj,set_size,FL_SMALL_FONT);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,150.0,80.0,120.0,30.0,"Normal");
    fl_set_call_back(obj,set_size,FL_NORMAL_FONT);
    fl_set_button(obj,1);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,280.0,80.0,120.0,30.0,"Large");
    fl_set_object_lsize(obj,FL_LARGE_FONT);
    fl_set_call_back(obj,set_size,FL_LARGE_FONT);
  fl_end_group();
  fl_bgn_group();
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,20.0,30.0,120.0,30.0,"Normal");
    fl_set_call_back(obj,set_style,FL_NORMAL_STYLE);
    fl_set_button(obj,1);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,150.0,30.0,120.0,30.0,"Bold");
    fl_set_call_back(obj,set_style,FL_BOLD_STYLE);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,280.0,30.0,120.0,30.0,"Italic");
    fl_set_call_back(obj,set_style,FL_ITALIC_STYLE);
  obj = fl_add_lightbutton(FL_RADIO_BUTTON,410.0,30.0,120.0,30.0,"Fixed");
    fl_set_call_back(obj,set_style,FL_FIXED_STYLE);
  fl_end_group();
  fl_end_form();
}

main()
{
  FL_OBJECT *obj;
  int i,j;
  char ttt[80];
  fl_init();
  create_form();
  for (i=0; i<4; i++)
    for (j=1; j<=100; j++)
    {
      sprintf(ttt,"Line %3i",j);
      fl_add_browser_line(br[i],ttt);
    }
  fl_show_form(form,FL_PLACE_CENTER,FALSE,NULL);
  do obj = fl_do_forms(); while (obj != exitobj);
  fl_hide_form(form);
}

